﻿using System;
using NHibernate.Dialect;
using NUnit.Framework;

namespace NHibernate.Test.NHSpecificTest.NH2660
{
    [TestFixture]
    public class Test : BugTestCase
    {
        protected override void OnSetUp()
        {
            base.OnSetUp();
            using (ISession session = OpenSession())
            {
                DomainClass entity = new DomainClass { Id = 1, Data = DateTime.Parse("10:00") };
                session.Save(entity);
                session.Flush();
            }
        }

        protected override void OnTearDown()
        {
            base.OnTearDown();
            using (ISession session = OpenSession())
            {
                const string hql = "from System.Object";
                session.Delete(hql);
                session.Flush();
            }
        }

        protected override bool AppliesTo(Dialect.Dialect dialect)
        {
            return dialect as MsSql2008Dialect != null;
        }

        [Test]
        public void ShouldBeAbleToQueryEntity()
        {
            using (ISession session = OpenSession())
            {
               var query =
                    session.CreateQuery(
                        @"from DomainClass entity where Data = :data");
                query.SetParameter("data", DateTime.Parse("10:00"), NHibernateUtil.Time);
                query.List();
            }
        }
    }
}
